﻿using System;
using System.Linq;
using System.Windows.Forms;

using System.Net.NetworkInformation;
using System.Net;
using System.Net.Sockets;

namespace NetworkTools
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void pingButton_Click(object sender, EventArgs e)
        {
            try
            {
                int c = 3;
                IPAddress ipAddress = Dns.GetHostEntry(hostTextBox.Text).AddressList[0];

                resultsListView.Items.Clear();

                for (int i = 0; i < c; i++)
                {
                    System.Net.NetworkInformation.Ping ping = 
                        new System.Net.NetworkInformation.Ping();

                    System.Net.NetworkInformation.PingReply pingReply = 
                        ping.Send(ipAddress);

                    ListViewItem result = new ListViewItem(pingReply.Address.ToString());
                    result.SubItems.Add(pingReply.Buffer.Count().ToString());
                    result.SubItems.Add(pingReply.RoundtripTime.ToString());
                    result.SubItems.Add(pingReply.Options.Ttl.ToString());
                    result.SubItems.Add(pingReply.Status.ToString());
                    resultsListView.Items.Add(result);

                    System.Threading.Thread.Sleep(100);
                }
            }
            catch (SocketException)
            {
                MessageBox.Show("Could not resolve host name.");
            }
            catch (PingException ex)
            {
                MessageBox.Show(ex.Message);
            }
            catch (ArgumentNullException)
            {
                MessageBox.Show("Please enter the host name or IP address to ping.");
            }

            hostTextBox.Focus();
        }

        private void lookupButton_Click(object sender, EventArgs e)
        {
            try
            {
                IPHostEntry hostEntry = Dns.GetHostEntry(lookupHostTextBox.Text);
                lookupListView.Items.Clear();
                foreach (IPAddress ipAddress in hostEntry.AddressList)
                    lookupListView.Items.Add(ipAddress.ToString());
            }
            catch (ArgumentNullException)
            {
                MessageBox.Show("Please enter the host name or IP address to ping.");
            }
            catch (ArgumentOutOfRangeException)
            {
                MessageBox.Show("The host name should be less than 127 characters");
            }
            catch (SocketException)
            {
                MessageBox.Show("Could not resolve host name.");
            }

            hostTextBox.Focus();
        }

        private void browseButton_Click(object sender, EventArgs e)
        {
            if (saveFileDialog.ShowDialog(this) == DialogResult.OK)
                saveAsTextBox.Text = saveFileDialog.FileName;
        }

        private void downloadButton_Click(object sender, EventArgs e)
        {
            System.Net.WebClient Client = new System.Net.WebClient();
            Client.DownloadFile(fileUrlTextBox.Text, saveAsTextBox.Text);
        }
    }
}
